---
title: Data URLs
slug: Web/HTTP/Basics_of_HTTP/Data_URIs
tags:
  - Base64
  - Guide
  - HTTP
  - Intermediate
  - URL
---
<div>{{HTTPSidebar}}</div>

<p><strong>Data URLs</strong>, URLs prefixed with the <code>data:</code> scheme, allow content creators to embed small files inline in documents. They were formerly known as "data URIs" until that name was retired by the WHATWG.</p>

<div class="note">
<p><strong>Note</strong>: Data URLs are treated as unique opaque origins by modern browsers, rather than inheriting the origin of the settings object responsible for the navigation.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<p>Data URLs are composed of four parts: a prefix (<code>data:</code>), a <a href="/en-US/docs/Web/HTTP/Basics_of_HTTP/MIME_types">MIME type</a> indicating the type of data, an optional <code>base64</code> token if non-textual, and the data itself:</p>

<pre class="syntaxbox notranslate">data:[&lt;mediatype&gt;][;base64],&lt;data&gt;
</pre>

<p>The <code>mediatype</code> is a <a href="/en-US/docs/Web/HTTP/Basics_of_HTTP/MIME_types">MIME type</a> string, such as <code>'image/jpeg'</code> for a JPEG image file. If omitted, defaults to <code>text/plain;charset=US-ASCII</code></p>

<p>If the data is textual, you can embed the text (using the appropriate entities or escapes based on the enclosing document's type). Otherwise, you can specify <code>base64</code> to embed base64-encoded binary data. You can find more info on MIME types <a href="/en-US/docs/Web/HTTP/Basics_of_HTTP/MIME_types">here</a> and <a href="/en-US/docs/Web/HTTP/Basics_of_HTTP/MIME_types/Complete_list_of_MIME_types">here</a>.</p>

<p>A few examples:</p>

<dl>
 <dt><code>data:,Hello%2C%20World!</code></dt>
 <dd>Simple text/plain data. Note the use of <a href="/en-US/docs/Glossary/percent-encoding">percent-encoding</a> (URL-encoding) for the quote and space characters. Also, for CSV data (MIME type "text/csv"), percent-encoding is needed to preserve the line endings that delimit rows of the spreadsheet.</dd>
 <dt><code>data:text/plain;base64,SGVsbG8sIFdvcmxkIQ==</code></dt>
 <dd>base64-encoded version of the above</dd>
 <dt><code>data:text/html,%3Ch1%3EHello%2C%20World!%3C%2Fh1%3E</code></dt>
 <dd>An HTML document with <code>&lt;h1&gt;Hello, World!&lt;/h1&gt;</code></dd>
 <dt><code>data:text/html,&lt;script&gt;alert('hi');&lt;/script&gt;</code></dt>
 <dd>An HTML document that executes a JavaScript alert. Note that the closing script tag is required.</dd>
</dl>

<h2 id="Encoding_data_into_base64_format">Encoding data into base64 format</h2>

<p>Base64 is a group of binary-to-text encoding schemes that represent binary data in an ASCII string format by translating it into a radix-64 representation. By consisting only in ASCII characters, base64 strings are generally url-safe, and that's why they can be used to encode data in Data URLs.</p>

<h3 id="Encoding_in_Javascript">Encoding in Javascript</h3>

<p>The Web APIs have native methods to encode or decode to base64: <a href="/en-US/docs/Web/API/WindowBase64/Base64_encoding_and_decoding">Base64 encoding and decoding</a>.</p>

<h3 id="Encoding_on_a_Unix_system">Encoding on a Unix system</h3>

<p>Base64 encoding of a file or string on Linux and Mac OS X systems can be achieved using the command-line <code>base64</code> (or, as an alternative, the <code>uuencode</code> utility with <code>-m</code> argument).</p>

<pre class="brush: bash notranslate">echo -n hello|base64
# outputs to console: aGVsbG8=

echo -n hello&gt;a.txt
base64 a.txt
# outputs to console: aGVsbG8=

base64 a.txt&gt;b.txt
# outputs to file b.txt: aGVsbG8=
</pre>

<h3 id="Encoding_on_Microsoft_Windows">Encoding on Microsoft Windows</h3>

<p>On Windows, <a href="https://docs.microsoft.com/en-us/dotnet/api/system.convert.tobase64string?view=net-5.0">Convert.ToBase64String</a> from PowerShell can be used to perform the Base64 encoding:</p>

<pre class="syntaxbox notranslate">[convert]::ToBase64String([Text.Encoding]::UTF8.GetBytes("hello"))
# outputs to console: aGVsbG8=
</pre>

<p>Alternatively, a GNU/Linux shell (such as <a href="https://en.wikipedia.org/wiki/Windows_Subsystem_for_Linux">WSL</a>) provides the utility <code>base64</code>:</p>

<pre class="syntaxbox notranslate">bash$ echo -n hello | base64
# outputs to console: aGVsbG8=
</pre>

<h2 id="Common_problems">Common problems</h2>

<p>This section describes problems that commonly occur when creating and using <code>data</code> URLs.</p>

<pre class="notranslate">data:text/html,lots of text...&lt;p&gt;&lt;a name%3D"bottom"&gt;bottom&lt;/a&gt;?arg=val
</pre>

<p>This represents an HTML resource whose contents are:</p>

<pre class="notranslate">lots of text...&lt;p&gt;&lt;a name="bottom"&gt;bottom&lt;/a&gt;?arg=val
</pre>

<dl>
 <dt>Syntax</dt>
 <dd>The format for <code>data</code> URLs is very simple, but it's easy to forget to put a comma before the "data" segment, or to incorrectly encode the data into base64 format.</dd>
 <dt>Formatting in HTML</dt>
 <dd>A <code>data</code> URL provides a file within a file, which can potentially be very wide relative to the width of the enclosing document. As a URL, the <code>data</code> should be formatable with whitespace (linefeed, tab, or spaces), but there are practical issues that arise <a class="external" href="http://bugzilla.mozilla.org/show_bug.cgi?id=73026#c12">when using base64 encoding</a>.</dd>
 <dt>Length limitations</dt>
 <dd>Although Firefox supports <code>data</code> URLs of essentially unlimited length, browsers are not required to support any particular maximum length of data. For example, the Opera 11 browser limited URLs to 65535 characters long which limits <code>data</code> URLs to 65529 characters (65529 characters being the length of the encoded data, not the source, if you use the plain <code>data:</code>, without specifying a MIME type).</dd>
 <dt>Lack of error handling</dt>
 <dd>Invalid parameters in media, or typos when specifying <code>'base64'</code>, are ignored, but no error is provided.</dd>
 <dt>No support for query strings, etc.</dt>
 <dd>
 <p>The data portion of a data URL is opaque, so an attempt to use a query string (page-specific parameters, with the syntax <code>&lt;url&gt;?parameter-data</code>) with a data URL will just include the query string in the data the URL represents.</p>
 </dd>
 <dt>Security issues</dt>
 <dd>A number of security issues (e.g. phishing) have been associated with data URLs, and navigating to them in the browser's top level. To mitigate such issues, top-level navigation to <code>data://</code> URLs has been blocked in Firefox 59+ (release version, Nightly/Beta from 58), and we hope to see other browsers follow suit soon. <a href="https://blog.mozilla.org/security/2017/11/27/blocking-top-level-navigations-data-urls-firefox-58/">See Blocking Top-Level Navigations to data URLs for Firefox 58</a> for more details.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Title</th>
  </tr>
  <tr>
   <td>{{RFC("2397")}}</td>
   <td>The "data" URL scheme</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{compat("http.data-url")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WindowBase64/Base64_encoding_and_decoding">Base64 encoding and decoding</a></li>
 <li><a href="/en-US/docs/Glossary/percent-encoding">Percent encoding</a></li>
 <li>{{domxref("WindowBase64.atob","atob()")}}</li>
 <li>{{domxref("WindowBase64.btoa","btoa()")}}</li>
 <li><a href="/en-US/docs/Web/CSS/uri">CSS <code>url()</code></a></li>
 <li><a href="/en-US/docs/Glossary/URI">URI</a></li>
</ul>
